//
//  Preferences
//
// Guit GUI Toolkit (https://www.telecom-paris.fr/~elc/guit/)
// Copyright 2020 Eric Lecolinet (eric.lecolinet@gmail.com) - Telecom Paris
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

#ifndef Guit_Prefs_hpp
#define Guit_Prefs_hpp
#include <gtypes.hpp>
namespace guit {
  
  /// Preferences.
  class GPrefs {
  public:
    static GTheme& theme();
    static GString const &openDir(), &saveDir();
    static GStrings const& fontDirs();
    static GStrings const& sansFonts();
    static GStrings const& serifFonts();
    static GStrings const& monoFonts();

    static int precision();
    static GTime dblclickDelay(), tipDelay(), animTimeout();  // in msec
    static float iconWidth(), menuTab();
    static float wheelGain();

    static GRgba const& selectedTextColor();
    static GRgba const& caretColor();
    static float caretWidth(), caretEndDist();
    static int   caretScroll();

    static float resizeHandleSize(), resizeFrameShift();
    static GRgba const &resizeHandleColor(), &resizeFrameColor();

    static GColor &inspectColor(), &inspectedColor();
    
  protected:
    GPrefs();
    GRgba *selectionColor_, *caretColor_;
    GEventState inspecthotkey_;
    GColor *inspectcolor_{}, *inspectedcolor_{};
    GStrings fontdirs_, sansfonts_, seriffonts_, monofonts_;
  };
  
}
#endif
