
//
// Hotkeys
//
// Guit GUI Toolkit (https://www.telecom-paris.fr/~elc/guit/)
// Copyright 2020 Eric Lecolinet (eric.lecolinet@gmail.com) - Telecom Paris
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

#ifndef Guit_Hotkey_hpp
#define Guit_Hotkey_hpp
#include <gprop.hpp>
namespace guit {

/// Hot key.
class GHotkey : public GProp {
public:
  GHotkey(GString const& hotkey_code = "");
  GHotkey* clone(bool copy_value) const override;

  using GType = GPropType_<GHotkey,GProp>;
  static GType& Type();
  GType& type() const override {return Type();}

  void apply(Gadget*, GRender&, Specif) override;
  void onRemove(Gadget*) override;

  /// @internal
  /// @{
  GString text_;
  // NOTE: GKeyCode and GEventState must not exceed 32 bits.
  union {
    uint64_t mapcode_;
    struct {
      GEventState modifiers;
      GKeyCode key;
    } value_;
  };
  /// @}
};

}
#endif
